diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha.module b/drupal7/sites/all/modules/recaptcha/recaptcha.module
index fe4fd7dd..1e65aab4 100644
--- a/drupal7/sites/all/modules/recaptcha/recaptcha.module
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha.module
@@ -2,53 +2,54 @@
 
 /**
  * @file
- * Uses the reCAPTCHA web service to improve the CAPTCHA system.
+ * Verifies if user is a human without necessity to solve a CAPTCHA.
  */
 
+require_once dirname(__FILE__) . '/recaptcha-php/src/ReCaptcha/ReCaptcha.php';
+require_once dirname(__FILE__) . '/recaptcha-php/src/ReCaptcha/RequestMethod.php';
+require_once dirname(__FILE__) . '/recaptcha-php/src/ReCaptcha/RequestParameters.php';
+require_once dirname(__FILE__) . '/recaptcha-php/src/ReCaptcha/Response.php';
+require_once dirname(__FILE__) . '/src/ReCaptcha/RequestMethod/Drupal7Post.php';
+
 /**
  * Implements hook_help().
  */
 function recaptcha_help($path, $arg) {
-  $output = '';
-
   switch ($path) {
-    case 'admin/modules#name':
-      $output .= t('reCAPTCHA');
-      break;
-
-    case 'admin/modules#description':
-    case 'admin/user/captcha/recaptcha':
-      $output .= t('Uses the <a href="@url" target="_blank">reCAPTCHA</a> web service to improve the CAPTCHA system and protect email addresses.', array('@url' => url('https://www.google.com/recaptcha')));
-      break;
-
-    case 'admin/help#recaptcha':
-      $output .= '<p>' .
-        t('Uses the reCAPTCHA web service to improve the CAPTCHA module and protect email addresses. For more information on what reCAPTCHA is, visit <a href="@url" target="_blank">the official website</a>.', array('@url' => url('https://www.google.com/recaptcha'))) .
-        '</p><h3>' .
-        t('Configuration') .
-        '</h3><p>' .
-        t('The settings associated with reCAPTCHA can be found in the <a href="@recaptchatab">reCAPTCHA tab</a>, in the <a href="@captchasettings">CAPTCHA settings</a>. You must set your public and private reCAPTCHA keys in order to use the module. Once the public and private keys are set, visit the <a href="@captchasettings">CAPTCHA settings</a>, where you can choose where reCAPTCHA should be displayed.', array('@recaptchatab' => url('admin/user/captcha/recaptcha'), '@captchasettings' => url('admin/user/captcha'))) .
-        '</p>';
-      break;
+    case 'admin/config/people/captcha/recaptcha':
+      return t('Google <a href="@url">reCAPTCHA</a> is a free service to protect your website from spam and abuse. reCAPTCHA uses an advanced risk analysis engine and adaptive CAPTCHAs to keep automated software from engaging in abusive activities on your site. It does this while letting your valid users pass through with ease.', array('@url' => 'https://www.google.com/recaptcha'));
   }
+}
 
-  return $output;
+/**
+ * Implements hook_theme().
+ */
+function recaptcha_theme() {
+  return array(
+    'recaptcha_widget_noscript' => array(
+      'variables' => array(
+        'widget' => NULL,
+      ),
+      'template' => 'recaptcha-widget-noscript',
+    ),
+  );
 }
 
 /**
  * Implements hook_menu().
  */
 function recaptcha_menu() {
-  $items = array();
   $items['admin/config/people/captcha/recaptcha'] = array(
     'title' => 'reCAPTCHA',
-    'description' => 'Administer the reCAPTCHA web service.',
+    'description' => 'Administer the Google No CAPTCHA reCAPTCHA web service.',
     'page callback' => 'drupal_get_form',
     'page arguments' => array('recaptcha_admin_settings'),
     'access arguments' => array('administer recaptcha'),
     'type' => MENU_LOCAL_TASK,
     'file' => 'recaptcha.admin.inc',
+    'weight' => 1,
   );
+
   return $items;
 }
 
@@ -58,8 +59,8 @@ function recaptcha_menu() {
 function recaptcha_permission() {
   return array(
     'administer recaptcha' => array(
-      'title' => t('reCaptcha Administration'),
-      'description' => t('Administer reCaptcha settings'),
+      'title' => t('Administer reCAPTCHA'),
+      'description' => t('Administer reCAPTCHA settings'),
     ),
   );
 }
@@ -68,6 +69,8 @@ function recaptcha_permission() {
  * Implements hook_captcha().
  */
 function recaptcha_captcha($op, $captcha_type = '') {
+  global $language;
+
   switch ($op) {
     case 'list':
       return array('reCAPTCHA');
@@ -75,94 +78,60 @@ function recaptcha_captcha($op, $captcha_type = '') {
     case 'generate':
       $captcha = array();
       if ($captcha_type == 'reCAPTCHA') {
-        // Retrieve configuration variables.
-        $recaptcha_theme = variable_get('recaptcha_theme', 'red');
-        $recaptcha_tabindex = variable_get('recaptcha_tabindex', NULL);
-        $recaptcha_public_key = variable_get('recaptcha_public_key', FALSE);
-        $recaptcha_ajax_api = variable_get('recaptcha_ajax_api', FALSE);
-
-        // Test if reCAPTCHA can be used, falling back to Math if it is not
-        // configured, the library won't load, or the server is down.
-        if (!$recaptcha_public_key || !_recaptcha_load_library() || !_recaptcha_server_is_up()) {
-          return captcha_captcha('generate', 'Math');
-        }
-
-        if ($recaptcha_ajax_api) {
-          // By default CAPTCHA turns off page caching on any page where a
-          // CAPTCHA challenge appears. If recaptcha is using AJAX API, set
-          // caching back to its old state as stored in DB.
-          global $conf;
-          $conf['cache'] = unserialize(db_query("SELECT value FROM {variable} WHERE name = 'cache'")->fetchField());
-        }
-
-        $recaptcha_options = array(
-          'theme' => $recaptcha_theme,
-        );
-
-        // Localization support.
-        global $language;
-        if (isset($language->language)) {
-          // reCAPTCHA uses two-character language codes, so 'pt-br' must be
-          // passed as 'pt'.
-          $recaptcha_options['lang'] = drupal_substr($language->language, 0, 2);
-        }
-
-        // Construct the Javascript, but only display it once.
-        static $_recaptcha_jsadded = FALSE;
-        if ($_recaptcha_jsadded == FALSE && $recaptcha_ajax_api == FALSE) {
-          $_recaptcha_jsadded = TRUE;
-
-          // Add support to display the custom theme.
-          if ($recaptcha_theme == 'custom') {
-            $recaptcha_options['custom_theme_widget'] = 'recaptcha_custom_theme_widget';
-          }
+        $recaptcha_site_key = variable_get('recaptcha_site_key', '');
+        $recaptcha_secret_key = variable_get('recaptcha_secret_key', '');
+
+        if (!empty($recaptcha_site_key) && !empty($recaptcha_secret_key)) {
+          // Build the reCAPTCHA captcha form if site_key and secret_key are
+          // configured. Captcha requires TRUE to be returned in solution.
+          $captcha['solution'] = TRUE;
+          $captcha['captcha_validate'] = 'recaptcha_captcha_validation';
+          $captcha['form']['captcha_response'] = array(
+            '#type' => 'hidden',
+            '#value' => 'Google no captcha',
+          );
 
-          // Set the default tab index.
-          if (!empty($recaptcha_tabindex)) {
-            $recaptcha_options['tabindex'] = $recaptcha_tabindex;
+          $noscript = '';
+          if (variable_get('recaptcha_noscript', 0)) {
+            $variables = array(
+              'sitekey' => $recaptcha_site_key,
+              'language' => $language->language,
+            );
+            $noscript = theme('recaptcha_widget_noscript', array('widget' => $variables));
           }
-          drupal_add_js('var RecaptchaOptions = ' . drupal_json_encode($recaptcha_options) . ';', array('type' => 'inline'));
-        }
 
-        // Create the form. Captcha requires TRUE to be returned in solution.
-        $captcha['solution'] = TRUE;
-        $captcha['captcha_validate'] = 'recaptcha_captcha_validation';
-
-        // If 'Disable Client-Side Cookies' is set, then add query string to
-        // end of the public key string before passing to recaptchalib.
-        if (variable_get('recaptcha_nocookies', FALSE)) {
-          $recaptcha_public_key .= '&nocookie=1';
-        }
+          $attributes = array(
+            'class' => 'g-recaptcha',
+            'data-sitekey' => $recaptcha_site_key,
+            'data-theme' => variable_get('recaptcha_theme', 'light'),
+            'data-type' => variable_get('recaptcha_type', 'image'),
+            'data-size' => variable_get('recaptcha_size', ''),
+            'data-tabindex' => variable_get('recaptcha_tabindex', 0),
+          );
+          // Filter out empty tabindex/size.
+          $attributes = array_filter($attributes);
 
-        $captcha['form']['captcha_response'] = array(
-          '#type' => 'hidden',
-          '#value' => 'reCAPTCHA',
-        );
+          $captcha['form']['recaptcha_widget'] = array(
+            '#markup' => '<div' . drupal_attributes($attributes) . '></div>',
+            '#suffix' => $noscript,
+          );
 
-        // Expose the form, either straight HTML, or using the AJAX API.
-        // Build the custom theme HTML if necessary.
-        $recaptcha_custom_html = ($recaptcha_theme == 'custom') ? theme('recaptcha_custom_widget') : '';
-        if ($recaptcha_ajax_api == FALSE) {
-          // Only generate recaptcha_get_html() if we're not using the AJAX API.
-          $html = recaptcha_get_html($recaptcha_public_key, NULL, TRUE);
-          $captcha['form']['captcha_form'] = array(
-            '#type' => 'item',
-            '#markup' => (!empty($recaptcha_custom_html) ? '<div id="recaptcha_custom_theme_widget">' . $recaptcha_custom_html . '</div>' : '') . $html,
+          // @todo: #1664602: D7 does not yet support "async" in drupal_add_js().
+          // drupal_add_js(url('https://www.google.com/recaptcha/api.js', array('query' => array('hl' => $language->language), 'absolute' => TRUE)), array('defer' => TRUE, 'async' => TRUE, 'type' => 'external'));
+          $data = array(
+            '#tag' => 'script',
+            '#value' => '',
+            '#attributes' => array(
+              'src' => url('https://www.google.com/recaptcha/api.js', array('query' => array('hl' => $language->language), 'absolute' => TRUE)),
+              'async' => 'async',
+              'defer' => 'defer',
+            ),
           );
+          drupal_add_html_head($data, 'recaptcha_api');
         }
         else {
-          $captcha['form']['captcha_form'] = array(
-            '#type' => 'item',
-            // Create the destination container, inserting any custom theme HTML
-            // necessary ($recaptcha_custom_html will be empty if we are not
-            // using custom theme).
-            '#markup' => '<div id="recaptcha_ajax_api_container">' . $recaptcha_custom_html . '</div>',
-          );
-          drupal_add_js('https://www.google.com/recaptcha/api/js/recaptcha_ajax.js', array('type' => 'external'));
-          $recaptcha_options['public_key'] = $recaptcha_public_key;
-          $recaptcha_options['container'] = 'recaptcha_ajax_api_container';
-          drupal_add_js(array('recaptcha' => $recaptcha_options), 'setting');
-          drupal_add_js(drupal_get_path('module', 'recaptcha') . '/recaptcha.js');
+          // Fallback to Math captcha as reCAPTCHA is not configured.
+          $captcha = captcha_captcha('generate', 'Math');
         }
       }
       return $captcha;
@@ -170,114 +139,53 @@ function recaptcha_captcha($op, $captcha_type = '') {
 }
 
 /**
- * Test whether the reCAPTCHA server is up.
- *
- * @return bool
- *   TRUE if the reCAPTCHA server is up, FALSE otherwise.
+ * CAPTCHA Callback; Validates the reCAPTCHA code.
  */
-function _recaptcha_test_recaptcha_server() {
-  $response = drupal_http_request('https://' . RECAPTCHA_VERIFY_SERVER);
-  if (empty($response->error)) {
-    return TRUE;
-  }
-  else {
-    watchdog('reCAPTCHA', 'Unable to connect with the reCAPTCHA server (@server): @errno: @errstr', array(
-      '@server' => RECAPTCHA_VERIFY_SERVER,
-      '@errno' => $response->code,
-      '@errstr' => $response->error,
-    ), WATCHDOG_ERROR);
+function recaptcha_captcha_validation($solution, $response, $element, $form_state) {
+  $recaptcha_secret_key = variable_get('recaptcha_secret_key', '');
+  if (empty($_POST['g-recaptcha-response']) || empty($recaptcha_secret_key)) {
     return FALSE;
   }
-}
 
-/**
- * Return the cached output of _recaptcha_test_recaptcha_server().
- *
- * @return bool
- *   TRUE if the reCAPTCHA server was up last time it was checked, FALSE
- *   otherwise.
- */
-function _recaptcha_server_is_up() {
-  static $server_status;
-  // Use static cache value, if available.
-  if (isset($server_status)) {
-    return $server_status;
-  }
-  // Check if the status is cached already.
-  $status_cache = cache_get('recaptcha_server_status');
-  if ($status_cache !== FALSE) {
-    $server_status = (bool) $status_cache;
-    return $server_status;
-  }
-  // Status is not cached. Check if server is up.
-  $server_status = _recaptcha_test_recaptcha_server();
+  // Use drupal_http_request() to circumvent all issues with the Google library.
+  $recaptcha = new \ReCaptcha\ReCaptcha($recaptcha_secret_key, new \ReCaptcha\RequestMethod\Drupal7Post());
 
-  // Set to 5 minutes, if interval is not set.
-  $cache_period = variable_get('recaptcha_server_status_check_interval', 5);
-  // Save it as integer as cache_get returns FALSE, if not found.
-  cache_set('recaptcha_server_status', (int) $server_status, 'cache', time() + ($cache_period * 60));
-  return $server_status;
-}
+  $resp = $recaptcha->verify(
+    $_POST['g-recaptcha-response'],
+    ip_address()
+  );
 
-/**
- * CAPTCHA Callback; Validates the reCAPTCHA code.
- */
-function recaptcha_captcha_validation($solution = NULL, $response = NULL) {
-  global $user;
-  $recaptcha_private_key = variable_get('recaptcha_private_key', FALSE);
-  $ip_address = ip_address();
-  if ($recaptcha_private_key && $ip_address && $response === 'reCAPTCHA' && !empty($_POST['recaptcha_challenge_field']) && !empty($_POST['recaptcha_response_field']) && _recaptcha_server_is_up()) {
-    $resp = recaptcha_check_answer(
-      $recaptcha_private_key,
-      $ip_address,
-      check_plain($_POST['recaptcha_challenge_field']),
-      check_plain($_POST['recaptcha_response_field'])
+  if ($resp->isSuccess()) {
+    // Verified!
+    return TRUE;
+  }
+  else {
+    // Error code reference, https://developers.google.com/recaptcha/docs/verify
+    $error_codes = array(
+      'missing-input-secret' => t('The secret parameter is missing.'),
+      'invalid-input-secret' => t('The secret parameter is invalid or malformed.'),
+      'missing-input-response' => t('The response parameter is missing.'),
+      'invalid-input-response' => t('The response parameter is invalid or malformed.'),
+      'invalid-json' => t('The json response is invalid or malformed.'),
+      'unknown' => t('Unknown error.'),
     );
-    return $resp->is_valid;
+    foreach ($resp->getErrorCodes() as $code) {
+      if (!isset($error_codes[$code])) {
+        $code = 'unknown';
+      }
+      watchdog('reCAPTCHA web service', '@error', array('@error' => $error_codes[$code]), WATCHDOG_ERROR);
+    }
   }
   return FALSE;
 }
 
 /**
- * Implements hook_theme().
- */
-function recaptcha_theme() {
-  return array(
-    'recaptcha_custom_widget' => array(
-      'arguments' => array(),
-    ),
-  );
-}
-
-/**
- * Theme function: creates the custom themed recaptcha widget.
+ * Process variables for recaptcha-widget-noscript.tpl.php.
  *
- * @ingroup themeable
- */
-function theme_recaptcha_custom_widget() {
-  $recaptcha_only_if_incorrect_sol = t('Incorrect please try again');
-  $recaptcha_only_if_image_enter = t('Enter the words above:');
-  $recaptcha_only_if_audio_enter = t('Enter the words you hear:');
-  $recaptcha_get_another_captcha = t('Get another CAPTCHA');
-  $recaptcha_only_if_image = t('Get an audio CAPTCHA');
-  $recaptcha_only_if_audio = t('Get an image CAPTCHA');
-  $help = t('Help');
-  return <<<EOT
-    <div id="recaptcha_image"></div>
-    <div class="recaptcha_only_if_incorrect_sol" style="color:red">$recaptcha_only_if_incorrect_sol</div>
-    <span class="recaptcha_only_if_image">$recaptcha_only_if_image_enter</span>
-    <span class="recaptcha_only_if_audio">$recaptcha_only_if_audio_enter</span>
-    <input type="text" id="recaptcha_response_field" name="recaptcha_response_field" />
-    <div class="recaptcha_get_another_captcha"><a href="javascript:Recaptcha.reload()">$recaptcha_get_another_captcha</a></div>
-    <div class="recaptcha_only_if_image"><a href="javascript:Recaptcha.switch_type('audio')">$recaptcha_only_if_image</a></div>
-    <div class="recaptcha_only_if_audio"><a href="javascript:Recaptcha.switch_type('image')">$recaptcha_only_if_audio</a></div>
-    <div class="recaptcha_help"><a href="javascript:Recaptcha.showhelp()">$help</a></div>
-EOT;
-}
-
-/**
- * Load the recaptcha library.
+ * @see recaptcha-widget-noscript.tpl.php
  */
-function _recaptcha_load_library() {
-  return module_load_include('php', 'recaptcha', 'recaptcha-php-1.11/recaptchalib');
+function template_preprocess_recaptcha_widget_noscript(&$variables) {
+  $variables['sitekey']  = check_plain($variables['widget']['sitekey']);
+  $variables['language'] = check_plain($variables['widget']['language']);
+  $variables['url']      = check_url(url('https://www.google.com/recaptcha/api/fallback', array('query' => array('k' => $variables['widget']['sitekey'], 'hl' => $variables['widget']['language']), 'absolute' => TRUE)));
 }
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha.test b/drupal7/sites/all/modules/recaptcha/recaptcha.test
new file mode 100644
index 00000000..4afedf74
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha.test
@@ -0,0 +1,179 @@
+<?php
+
+/**
+ * @file
+ * Tests for reCAPTCHA module.
+ */
+class ReCaptchaBasicTest extends DrupalWebTestCase {
+
+  /**
+   * {@inheritdoc}
+   */
+  public static function getInfo() {
+    return array(
+      'name' => t('reCAPTCHA basic tests'),
+      'description' => t('Test basic functionality of reCAPTCHA module.'),
+      'group' => t('reCAPTCHA'),
+      'dependencies' => array('captcha'),
+    );
+  }
+
+  /**
+   * {@inheritdoc}
+   */
+  function setUp() {
+    parent::setUp('captcha', 'recaptcha');
+    module_load_include('inc', 'captcha');
+
+    // Create a normal user.
+    $permissions = array(
+      'access content',
+    );
+    $this->normal_user = $this->drupalCreateUser($permissions);
+
+    // Create an admin user.
+    $permissions += array(
+      'administer CAPTCHA settings',
+      'skip CAPTCHA',
+      'administer permissions',
+      'administer content types',
+      'administer recaptcha',
+    );
+    $this->admin_user = $this->drupalCreateUser($permissions);
+  }
+
+  /**
+   * Test access to the administration page.
+   */
+  function testReCaptchaAdminAccess() {
+    $this->drupalLogin($this->admin_user);
+    $this->drupalGet('admin/config/people/captcha/recaptcha');
+    $this->assertNoText(t('Access denied'), 'Admin users should be able to access the reCAPTCHA admin page', 'reCAPTCHA');
+    $this->drupalLogout();
+  }
+
+  /**
+   * Test the reCAPTCHA settings form.
+   */
+  function testReCaptchaAdminSettingsForm() {
+    $this->drupalLogin($this->admin_user);
+
+    $site_key = $this->randomName(40);
+    $secret_key = $this->randomName(40);
+
+    // Check form validation.
+    $edit['recaptcha_site_key'] = '';
+    $edit['recaptcha_secret_key'] = '';
+    $edit['recaptcha_tabindex'] = $this->randomName(2);
+    $this->drupalPost('admin/config/people/captcha/recaptcha', $edit, t('Save configuration'));
+
+    $this->assertRaw(t('Site key field is required.'), '[testReCaptchaConfiguration]: Empty site key detected.');
+    $this->assertRaw(t('Secret key field is required.'), '[testReCaptchaConfiguration]: Empty secret key detected.');
+    $this->assertRaw(t('The tabindex must be an integer.'), '[testReCaptchaConfiguration]: Invalid value for tab index detected.');
+
+    // Save form with valid values.
+    $edit['recaptcha_site_key'] = $site_key;
+    $edit['recaptcha_secret_key'] = $secret_key;
+    $edit['recaptcha_tabindex'] = 0;
+    $this->drupalPost('admin/config/people/captcha/recaptcha', $edit, t('Save configuration'));
+    $this->assertRaw(t('The configuration options have been saved.'), '[testReCaptchaConfiguration]: The configuration options have been saved.');
+
+    $this->assertNoRaw(t('Site key field is required.'), '[testReCaptchaConfiguration]: Site key was not empty.');
+    $this->assertNoRaw(t('Secret key field is required.'), '[testReCaptchaConfiguration]: Secret key was not empty.');
+    $this->assertNoRaw(t('The tabindex must be an integer.'), '[testReCaptchaConfiguration]: Tab index had a valid input.');
+
+    $this->drupalLogout();
+  }
+
+  /**
+   * Testing the protection of the user login form.
+   */
+  function testReCaptchaOnLoginForm() {
+    global $language;
+
+    $site_key = $this->randomName(40);;
+    $secret_key = $this->randomName(40);;
+    $grecaptcha = '<div class="g-recaptcha" data-sitekey="' . $site_key . '" data-theme="light" data-type="image"></div>';
+
+    // Test if login works.
+    $this->drupalLogin($this->normal_user);
+    $this->drupalLogout();
+
+    $this->drupalGet('user');
+    $this->assertNoRaw($grecaptcha, '[testReCaptchaOnLoginForm]: reCAPTCHA is not shown on form.');
+
+    // Enable 'captcha/Math' CAPTCHA on login form.
+    captcha_set_form_id_setting('user_login', 'captcha/Math');
+
+    $this->drupalGet('user');
+    $this->assertNoRaw($grecaptcha, '[testReCaptchaOnLoginForm]: reCAPTCHA is not shown on form.');
+
+    // Enable 'recaptcha/reCAPTCHA' on login form.
+    captcha_set_form_id_setting('user_login', 'recaptcha/reCAPTCHA');
+    $result = captcha_get_form_id_setting('user_login');
+    $this->assertNotNull($result, 'A configuration has been found for CAPTCHA point: user_login', 'reCAPTCHA');
+    $this->assertEqual($result->module, 'recaptcha', 'reCAPTCHA module configured for CAPTCHA point: user_login', 'reCAPTCHA');
+    $this->assertEqual($result->captcha_type, 'reCAPTCHA', 'reCAPTCHA type has been configured for CAPTCHA point: user_login', 'reCAPTCHA');
+
+    // Check if a Math CAPTCHA is still shown on the login form. The site key
+    // and security key have not yet configured for reCAPTCHA. The module need
+    // to fall back to math captcha.
+    $this->drupalGet('user');
+    $this->assertRaw(t('Math question'), '[testReCaptchaOnLoginForm]: Math CAPTCHA is shown on form.');
+
+    // Configure site key and security key to show reCAPTCHA and no fall back.
+    variable_set('recaptcha_site_key', $site_key);
+    variable_set('recaptcha_secret_key', $secret_key);
+
+    // Check if there is a reCAPTCHA on the login form.
+    $this->drupalGet('user');
+    $this->assertRaw($grecaptcha, '[testReCaptchaOnLoginForm]: reCAPTCHA is shown on form.');
+    $this->assertRaw('<script src="https://www.google.com/recaptcha/api.js?hl=' . $language->language . '" async="async" defer="defer"></script>', '[testReCaptchaOnLoginForm]: reCAPTCHA is shown on form.');
+    $this->assertNoRaw($grecaptcha . '<noscript>', '[testReCaptchaOnLoginForm]: NoScript code is not enabled for the reCAPTCHA.');
+
+    // Test if the fall back url is properly build and noscript code added.
+    variable_set('recaptcha_noscript', 1);
+    $this->drupalGet('user');
+    $this->assertRaw($grecaptcha . '<noscript>', '[testReCaptchaOnLoginForm]: NoScript for reCAPTCHA is shown on form.');
+    $this->assertRaw('https://www.google.com/recaptcha/api/fallback?k=' . $site_key . '&amp;hl=' . $language->language, '[testReCaptchaOnLoginForm]: Fallback URL with IFRAME has been found.');
+
+    // Check that data-size attribute does not exists.
+    variable_set('recaptcha_size', '');
+    $this->drupalGet('user');
+    $element = $this->xpath('//div[@class=:class and @data-size=:size]', array(':class' => 'g-recaptcha', ':size' => 'small'));
+    $this->assertFalse(!empty($element), 'Tag contains no data-size attribute.');
+
+    // Check that data-size attribute exists.
+    variable_set('recaptcha_size', 'small');
+    $this->drupalGet('user');
+    $element = $this->xpath('//div[@class=:class and @data-size=:size]', array(':class' => 'g-recaptcha', ':size' => 'small'));
+    $this->assertTrue(!empty($element), 'Tag contains data-size attribute and value.');
+
+    // Check that data-tabindex attribute does not exists.
+    variable_set('recaptcha_tabindex', 0);
+    $this->drupalGet('user');
+    $element = $this->xpath('//div[@class=:class and @data-tabindex=:index]', array(':class' => 'g-recaptcha', ':index' => 0));
+    $this->assertFalse(!empty($element), 'Tag contains no data-tabindex attribute.');
+
+    // Check that data-tabindex attribute exists.
+    variable_set('recaptcha_tabindex', 5);
+    $this->drupalGet('user');
+    $element = $this->xpath('//div[@class=:class and @data-tabindex=:index]', array(':class' => 'g-recaptcha', ':index' => 5));
+    $this->assertTrue(!empty($element), 'Tag contains data-tabindex attribute and value.');
+
+    // Try to log in, which should fail.
+    $edit['name'] = $this->normal_user->name;
+    $edit['pass'] = $this->normal_user->pass_raw;
+    $edit['captcha_response'] = '?';
+
+    $this->drupalPost('user', $edit, t('Log in'));
+    // Check for error message.
+    $this->assertText(t('The answer you entered for the CAPTCHA was not correct.'), 'CAPTCHA should block user login form', 'reCAPTCHA');
+
+    // And make sure that user is not logged in: check for name and password fields on ?q=user
+    $this->drupalGet('user');
+    $this->assertField('name', t('Username field found.'), 'reCAPTCHA');
+    $this->assertField('pass', t('Password field found.'), 'reCAPTCHA');
+  }
+
+}
diff --git a/drupal7/sites/all/modules/recaptcha/src/ReCaptcha/RequestMethod/Drupal7Post.php b/drupal7/sites/all/modules/recaptcha/src/ReCaptcha/RequestMethod/Drupal7Post.php
new file mode 100644
index 00000000..450b7392
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/src/ReCaptcha/RequestMethod/Drupal7Post.php
@@ -0,0 +1,43 @@
+<?php
+
+/**
+ * @file
+ * Custom Drupal 7 RequestMehod class for Google reCAPTCHA library.
+ */
+
+namespace ReCaptcha\RequestMethod;
+
+use ReCaptcha\RequestMethod;
+use ReCaptcha\RequestParameters;
+
+/**
+ * Sends POST requests to the reCAPTCHA service.
+ */
+class Drupal7Post implements RequestMethod {
+
+  /**
+   * URL to which requests are POSTed.
+   * @const string
+   */
+  const SITE_VERIFY_URL = 'https://www.google.com/recaptcha/api/siteverify';
+
+  /**
+   * Submit the POST request with the specified parameters.
+   *
+   * @param RequestParameters $params Request parameters
+   * @return string Body of the reCAPTCHA response
+   */
+  public function submit(RequestParameters $params) {
+
+    $options = array(
+      'headers' => array(
+        'Content-type' => 'application/x-www-form-urlencoded',
+      ),
+      'method' => 'POST',
+      'data' => $params->toQueryString(),
+    );
+    $response = drupal_http_request(self::SITE_VERIFY_URL, $options);
+
+    return isset($response->data) ? $response->data : '';
+  }
+}
